function [H,h] = SRconstraintCoeff2D(m,M,n,N)
% Computes the constraint coeffients for SR from m x n to M x N.
% See comments in SRconstraint1D and SRconstraint2D.
% This is not the constraint matrix R itself, but a matrix of the
% coeffients actually used in the SR algorithm to backproject the updates
% to fullfill the requirements given by R. R is the output of
% SRconstraint2D and can be used to initialize the HR values. 
%
% Sune Keller, ITU Copenhagen, 25-08-2006.


[G,g] = SRconstraint2D(m,M,n,N);

H = G*(inv((G')*G))*(G');

% the nomalization h = g = mn/MN cancles out in the operations and is
% obselete.
h = g;


% Incorrect code
% H = zeros(M*N,M*N);
% H = G*(G');

