function flow = PAP(I, gamma, alpha, levels, scale, fp, relax, thres)
%PAPMatlab: compute optical flow with Papenberg et alii non-linear algorithm
%
% I is the input (grayscale) image sequence, 
% gamma is the gradient matching weight,
% alpha is the regularization weight
% levels is the number of levels in the pyramid
% scale is the scale factor between the levels
% fp is the number of fixed point iterations at each level
% relax is the number of SOR relaxation iterations at each fixed point iteration
% thres is the convergence threshold for SOR
%
% copyright (C) 2005 Francois Lauze, the IT University of Copenhagen