/*********************************************
 * the matlab c++ source file for PAPMatlab  *
 *********************************************/

#include <PAP.h>

/******************************************************************************
 * call as flow = PAPMatlab(I, gamma, alpha, levels, scale, fp, relax, thres) *
 ******************************************************************************/

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	// no argument checking, done in the matlab calling routine (maybe...)
	CImg<float> I(prhs[0],false);
	double gamma = mxGetScalar(prhs[1]);
	double alpha = mxGetScalar(prhs[2]);
	unsigned levels = (unsigned)mxGetScalar(prhs[3]);
	double scale = mxGetScalar(prhs[4]);
	unsigned fp = (unsigned)mxGetScalar(prhs[5]);
	unsigned relax = (unsigned)mxGetScalar(prhs[6]);
	double thres = mxGetScalar(prhs[7]);

	PAP aPAP(I, gamma, alpha, levels, scale, fp, relax, thres);
	plhs[0] = aPAP.getFlow().toMatlab();
}