/*********************************************
 * the matlab c++ source file for SRsim      *
 *********************************************/

#include "SRsim.h"

/******************************************************************************
 * call as HRseq, fU, bU = SRsim(,, , , ,,,)								  *
 ******************************************************************************/

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	// no argument checking, done in the matlab calling routine (maybe...)
	CImg<float> I(prhs[0],false);
	CImg<float> bU(prhs[1],false);
	CImg<float> fU(prhs[2],false);
	double gamma = mxGetScalar(prhs[3]);
	double alpha = mxGetScalar(prhs[4]);
	//unsigned levels = (unsigned)mxGetScalar(prhs[]);
	//double scale = mxGetScalar(prhs[]);
	unsigned fp = (unsigned)mxGetScalar(prhs[5]);
	unsigned relax = (unsigned)mxGetScalar(prhs[6]);
	double thres = mxGetScalar(prhs[7]);
	unsigned lambdas = (unsigned)mxGetScalar(prhs[8]);
	unsigned lambdat = (unsigned)mxGetScalar(prhs[9]);
	unsigned fpI = (unsigned)mxGetScalar(prhs[10]);
	unsigned relaxI = (unsigned)mxGetScalar(prhs[11]);
	unsigned M = (unsigned)mxGetScalar(prhs[12]);
	unsigned N = (unsigned)mxGetScalar(prhs[13]);
	CImg<float> F(prhs[14],false);
	unsigned outerIte = (unsigned)mxGetScalar(prhs[15]);

	//mexPrintf("mexFunction efter indlaesning af data\n");
	SRsim aSRsim(I, bU, fU, gamma, alpha, fp, relax, thres, lambdas, lambdat, fpI, relaxI, M, N, F, outerIte);
	//mexPrintf("efter init af object\n");
	//CImg<float> result = aMCSR2x2.getSeq();
	//result.display("High res");
	//plhs[0] = result.toMatlab();
	plhs[0] = aSRsim.getSeq().toMatlab();
	plhs[1] = aSRsim.getfU().toMatlab();
	plhs[2] = aSRsim.getbU().toMatlab();

}
